about summary refs log tree commit diff
path: root/scripts
diff options
context:
space:
mode:
authorMichel Alexandre Salim <michel@sylvestre.me>2012-05-27T09·34+0700
committerEelco Dolstra <eelco.dolstra@logicblox.com>2012-05-31T12·59-0400
commit6a214f3e06fa1c5f0a4d40e555f14d87691af297 (patch)
tree82f8e4c150e052267cb1fa45e42136adb101c5bb /scripts
parentd0308073c35799cce98bc853eba64f3922fadcfd (diff)
Update nix profile: - incorporate NixOS's configuration so that nix is usable by normal users - install as a data file, not a program file
Diffstat (limited to 'scripts')
-rw-r--r--scripts/Makefile.am2
-rw-r--r--scripts/nix-profile.sh.in53
2 files changed, 47 insertions, 8 deletions
diff --git a/scripts/Makefile.am b/scripts/Makefile.am
index a5703760d1f7..18a59dbdb6f6 100644
--- a/scripts/Makefile.am
+++ b/scripts/Makefile.am
@@ -11,7 +11,7 @@ nix-pull nix-push: download-using-manifests.pl
 
 install-exec-local: download-using-manifests.pl copy-from-other-stores.pl find-runtime-roots.pl
 	$(INSTALL) -d $(DESTDIR)$(sysconfdir)/profile.d
-	$(INSTALL_PROGRAM) nix-profile.sh $(DESTDIR)$(sysconfdir)/profile.d/nix.sh
+	$(INSTALL_DATA) nix-profile.sh $(DESTDIR)$(sysconfdir)/profile.d/nix.sh
 	$(INSTALL) -d $(DESTDIR)$(libexecdir)/nix
 	$(INSTALL_PROGRAM) find-runtime-roots.pl $(DESTDIR)$(libexecdir)/nix 
 	$(INSTALL_PROGRAM) build-remote.pl $(DESTDIR)$(libexecdir)/nix 
diff --git a/scripts/nix-profile.sh.in b/scripts/nix-profile.sh.in
index 839531349734..d343385cc1e5 100644
--- a/scripts/nix-profile.sh.in
+++ b/scripts/nix-profile.sh.in
@@ -1,11 +1,50 @@
-if test -n "$HOME"; then
-    NIX_LINK="$HOME/.nix-profile"
+export NIX_USER_PROFILE_DIR=@localstatedir@/nix/profiles/per-user/$USER
+export NIX_PROFILES="@localstatedir@/nix/profiles/default $HOME/.nix-profile"
 
-    if ! test -L "$NIX_LINK"; then
-        echo "creating $NIX_LINK" >&2
-        _NIX_DEF_LINK=@localstatedir@/nix/profiles/default
-        @coreutils@/ln -s "$_NIX_DEF_LINK" "$NIX_LINK"
+# Set up the per-user profile.
+mkdir -m 0755 -p $NIX_USER_PROFILE_DIR
+if test "$(stat --printf '%u' $NIX_USER_PROFILE_DIR)" != "$(id -u)"; then
+    echo "WARNING: bad ownership on $NIX_USER_PROFILE_DIR" >&2
+fi
+
+if ! test -L $HOME/.nix-profile; then
+    echo "creating $HOME/.nix-profile" >&2
+    if test "$USER" != root; then
+        @coreutils@/ln -s $NIX_USER_PROFILE_DIR/profile $HOME/.nix-profile
+    else
+        # Root installs in the system-wide profile by default.
+        @coreutils@/ln -s /nix/var/nix/profiles/default $HOME/.nix-profile
     fi
+fi
+
+export PATH="$HOME/.nix-profile/bin:$PATH"
+
+# Subscribe the root user to the NixOS channel by default.
+if [ "$USER" = root -a ! -e $HOME/.nix-channels ]; then
+    echo "http://nixos.org/releases/nixos/channels/nixos-unstable nixos" > $HOME/.nix-channels
+fi
+
+# Create the per-user garbage collector roots directory.
+NIX_USER_GCROOTS_DIR=@localstatedir@/nix/gcroots/per-user/$USER
+mkdir -m 0755 -p $NIX_USER_GCROOTS_DIR
+if test "$(stat --printf '%u' $NIX_USER_GCROOTS_DIR)" != "$(id -u)"; then
+    echo "WARNING: bad ownership on $NIX_USER_GCROOTS_DIR" >&2
+fi
+
+# Set up a default Nix expression from which to install stuff.
+if [ ! -e $HOME/.nix-defexpr -o -L $HOME/.nix-defexpr ]; then
+    echo "creating $HOME/.nix-defexpr" >&2
+    rm -f $HOME/.nix-defexpr
+    mkdir $HOME/.nix-defexpr
+    if [ "$USER" != root ]; then
+        @coreutils@/ln -s @localstatedir@/nix/profiles/per-user/root/channels $HOME/.nix-defexpr/channels_root
+    fi
+fi
 
-    export PATH=$NIX_LINK/bin:$PATH
+# Set up secure multi-user builds: non-root users build through the
+# Nix daemon.
+if test "$USER" != root; then
+    export NIX_REMOTE=daemon
+else
+    unset NIX_REMOTE
 fi